$INCLUDE "rapidq.inc"
$TYPECHECK ON

$RESOURCE RunningIcon AS "C:\nybbledesigns\webserver\Mainicon.ico"
$RESOURCE StoppedIcon AS "C:\nybbledesigns\webserver\MainiconStopped.ico"
$RESOURCE ErrorIcon AS "C:\nybbledesigns\webserver\MainiconError.ico"
$RESOURCE StartupImg AS "C:\NybbleDesigns\WebServer\StartupImg.bmp"

'All API calls go here
DECLARE FUNCTION SetWindowLong LIB "User32" ALIAS "SetWindowLongA" (hwnd AS Long, nIndex AS Long, dwNewLong AS Long) AS LONG

'The server constants below must all be in upper case
CONST OurPath = UCase$(Mid$(Command$(0),1,Len(Command$(0)) - Len(Application.ExeName))) 'The path of the webserver
CONST DataFolder = "DATAFILES" 'The folder containing server data (MIME types etc.)
CONST LogFolder = "LOGS" 'The folder containing the server logs
CONST WebInterfaceFolder = "WEBINTERFACE" 'The folder with the admin web interface
CONST WebInterfaceFolderUserNamed = "ADMIN" 'The user's name for the admin web interface folder
CONST Delay = 300

'HTTP consts
CONST HttpProtocUsed = "HTTP/1.1"

'These constants are the different errors
CONST ContinueErrorData = "100 Continue"
CONST SwitchingProtocolsErrorData = "101 Switching Protocols"
CONST OKErrorData = "200 OK"
CONST CreatedErrorData = "201 Created"
CONST AcceptedErrorData = "202 Accepted"
CONST NonAuthoritativeInformationErrorData = "203 Non-Authoritative Information"
CONST NoContentErrorData = "204 No Content"
CONST ResetContentErrorData = "205 Reset Content"
CONST PartialContentErrorData = "206 Partial Content"
CONST MultipleChoicesErrorData = "300 Multiple Choices"
CONST MovedPermanentlyErrorData = "301 Moved Permanently"
CONST FoundErrorData = "302 Found"
CONST SeeOtherErrorData = "303 See Other"
CONST NotModifiedErrorData = "304 Not Modified"
CONST UseProxyErrorData = "305 Use Proxy"
CONST TemporaryRedirectErrorData = "307 Temporary Redirect"
CONST BadRequestErrorData = "400 Bad Request"
CONST UnauthorizedErrorData = "401 Unauthorized"
CONST PaymentRequiredErrorData = "402 Payment Required"
CONST ForbiddenErrorData = "403 Forbidden"
CONST NotFoundErrorData = "404 Not Found"
CONST MethodNotAllowedErrorData = "405 Method Not Allowed"
CONST NotAcceptableErrorData = "406 Not Acceptable"
CONST ProxyAuthenticationRequiredErrorData = "407 Proxy Authentication Required"
CONST RequestTimeoutErrorData = "408 Request Time-out"
CONST ConflictErrorData = "409 Conflict"
CONST GoneErrorData = "410 Gone"
CONST LengthRequiredErrorData = "411 Length Required"
CONST PreconditionFailedErrorData = "412 Precondition Failed"
CONST RequestEntityTooLargeErrorData = "413 Request Entity Too Large"
CONST RequestURITooLargeErrorData = "414 Request-URI Too Large"
CONST UnsupportedMediaTypeErrorData = "415 Unsupported Media Type"
CONST RequestedrangenotsatisfiableErrorData = "416 Requested range not satisfiable"
CONST ExpectationFailedErrorData = "417 Expectation Failed"
CONST InternalServerErrorErrorData = "500 Internal Server Error"
CONST NotImplementedErrorData = "501 Not Implemented"
CONST BadGatewayErrorData = "502 Bad Gateway"
CONST ServiceUnavailableErrorData = "503 Service Unavailable"
CONST GatewayTimeoutErrorData = "504 Gateway Time-out"
CONST HTTPVersionnotsupportedErrorData = "505 HTTP Version not supported"

'These constants show on webpages certain webserver variables
CONST ServerActingFolder = "<#+ServerActiveFolder+#>"  'The active folder
CONST ServerErrorPagesFolder = "<#+ServerErrorPagesFolder+#>" 'The server's error pages path
CONST ServerDataFolder = "<#+ServerDataFolder+#>" 'The server's data folder path
CONST ServerLogFolder = "<#+ServerLogFolder+#>" 'The server's log folder path
CONST ServerRequestPath = "<#+ServerRequestPath+#>"  'The requested path
CONST ServerStatus = "<#+ServerStatus+#>"  'The status of the server
CONST ServerHits = "<#+ServerHits+#>"  'The number of server hits
CONST ServerWebPageHits = "<#+ServerWebPageHits+#>"  'The number of webpage hits
CONST ServerErrorHits = "<#+ServerErrorHits+#>"  'The number of admin hits
CONST ServerAdminHits = "<#+ServerAdminHits+#>"  'The number of error hits
'=============================================================

DECLARE SUB Button1Click (Sender AS QBUTTON)
DECLARE SUB Button2Click (Sender AS QBUTTON)
DECLARE SUB Button3Click (Sender AS QBUTTON)
DECLARE SUB TimeOut
DECLARE SUB CloseProgram

DIM Socket AS QSOCKET
DIM SocketRefresh AS QTIMER
SocketRefresh.Enabled = 0
SocketRefresh.Interval = Delay
SocketRefresh.onTimer = TimeOut
DIM MySockIt AS INTEGER
DIM TheirSockIt AS INTEGER
DIM HeaderDataString AS STRING
DIM PageDataString AS STRING
DIM RequestData AS STRING
DIM FileStream AS QFILESTREAM
DIM FileStreamLine AS INTEGER
DIM ViewedMimeType AS STRING
DIM CurrentMimeData AS STRING
DIM LenMimeData AS INTEGER        
DIM LogFile AS QFILESTREAM
DIM LenRequestData AS INTEGER
DIM OldPos AS INTEGER
OldPos = 0
DIM Command AS STRING
DIM Path AS STRING
DIM Protocol AS STRING
DIM CommandAlloc AS INTEGER
DIM PathAlloc AS INTEGER
DIM ProtocolAlloc AS INTEGER
DIM MimeType AS STRING
DIM CompletePath AS STRING
DIM ErrorData AS STRING
DIM FileSize AS INTEGER
DIM OutputString AS STRING
DIM OurStatusSting AS STRING
OurStatusSting = "Stopped"
DIM NumHits AS INTEGER
DIM NumWebPageHits AS INTEGER
DIM NumErrorHits AS INTEGER
DIM NumAdminHits AS INTEGER
DIM AdminLoggedIn AS INTEGER
DIM FileStreamLineData AS STRING

Application.IcoHandle = StoppedIcon

CREATE Form AS QFORM
    Caption = "Nybble Webserver"
    onClose = CloseProgram
    BorderStyle = 1
    Width = 471
    Height = 309
    Left = 0
    Top = 0
    IcoHandle = StoppedIcon
    CREATE Panel1 AS QPANEL
        Left = 0
        Top = 241
        Width = 463
        BevelOuter = 0
        Align = 2
        CREATE Button1 AS QBUTTON
            Caption = "&Start"
            Left = 5
            Top = 4
            OnClick = Button1Click
        END CREATE
        CREATE Button2 AS QBUTTON
            Caption = "&Clear console"
            Left = 181
            Top = 4
            TabOrder = 1
            OnClick = Button2Click
        END CREATE
        CREATE Button3 AS QBUTTON
            Caption = "E&xit"
            Left = 381
            Top = 4
            TabOrder = 2
            OnClick = Button3Click
        END CREATE
    END CREATE
    CREATE ListBox1 AS QLISTBOX
        Left = 0
        Top = 0
        Width = 463
        Height = 241
        Align = 5
        BorderStyle = 0
        Color = -2147483633
        TabOrder = 1
    END CREATE
    DelBorderIcons(2)
END CREATE

CREATE LoadingForm AS QFORM
    Caption = ""
    Width = 294
    Height = 217
    BorderStyle = 1
    Color = 16777215
    Center
    HideTitleBar
    CREATE Image1 AS QIMAGE
        BMPHandle = StartupImg
        Left = 0
        Top = 0
        Width = 155
        Height = 150
        AutoSize = 1
    END CREATE
    CREATE LoadingPanel1 AS QPANEL
        Left = 92
        Top = 169
        Height = 14
        BevelOuter = 1
        CREATE LoadingGauge1 AS QGAUGE
            Align = 5
            Left = 1
            Top = 1
            Width = 183
            Height = 12
            BorderStyle = 0
            Kind = 1
            Max = 2
            BackColor = -2147483633
            ForeColor = 16737280
            ShowText = 0
        END CREATE
    END CREATE
END CREATE

'Loading routine
LoadingForm.Show
LoadingForm.Repaint

FileStream.Open(OurPath + DataFolder + "\Server.dat",fmOpenRead)
LoadingGauge1.Max = FileStream.LineCount + 2

DIM DocFolder AS STRING
DIM ErrorsFolder AS STRING
DIM AdminUserName AS STRING
DIM AdminPassword AS STRING
DocFolder = ""
ErrorsFolder = ""
AdminUserName = ""
AdminPassword = ""

For FileStreamLine = 0 To FileStream.LineCount
    FileStreamLineData = FileStream.ReadLine
    If UCase$(Left$(FileStreamLineData,Len("HTMLDOCPATH="))) = "HTMLDOCPATH=" Then
        If DirExists(OurPath + UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("HTMLDOCPATH=")))) Then
            DocFolder = UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("HTMLDOCPATH=")))
        Else
            $ESCAPECHARS ON
            Showmessage "Docs folder described in the server configure file does not exist\nApplication terminating..."
            $ESCAPECHARS OFF
            Application.Terminate
        End If
    End If
    If UCase$(Left$(FileStreamLineData,Len("ERRORPAGES="))) = "ERRORPAGES=" Then
        If DirExists(OurPath + UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("ERRORPAGES=")))) Then
            ErrorsFolder = UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("ERRORPAGES=")))
        Else
            $ESCAPECHARS ON
            Showmessage "Errors folder described in the server configure file does not exist\nApplication terminating..."
            $ESCAPECHARS OFF
            Application.Terminate
        End If
    End If
    If UCase$(Left$(FileStreamLineData,Len("ADMIN="))) = "ADMIN=" Then
        AdminUserName = UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("ADMIN=")))
    End If
    If UCase$(Left$(FileStreamLineData,Len("PASSWORD="))) = "PASSWORD=" Then
        AdminPassword = UCase$(Right$(FileStreamLineData,Len(FileStreamLineData) - Len("PASSWORD=")))
    End If
    LoadingGauge1.Position = LoadingGauge1.Position + 1
Next FileStreamLine

FileStream.Close

If DocFolder = "" Or ErrorsFolder = "" Or AdminUserName = "" Or AdminPassword = "" Then
    $ESCAPECHARS ON
    Showmessage "Missing information from server configuration file\nApplication terminating..."
    $ESCAPECHARS OFF
    Application.Terminate
End If

LogFile.Open(OurPath + LogFolder + "\logfile.log",fmCreate)

LoadingGauge1.Position = LoadingGauge1.Position + 1

'This makes the form correctly minimise
SetWindowLong Form.Handle, -8, 0
SetWindowLong Application.Handle, -8, Form.Handle
'======================================

LoadingGauge1.Position = LoadingGauge1.Position + 1

Sleep 3

LoadingForm.Close

'These constants are the admin commmands. MUST BE IN CAPITALS AND AFTER WHERE DATA IS LOADED
CONST AdminCommandLogout = "?LOGOUT"
CONST AdminCommandLogin = "?USERNAME=" + AdminUserName + "&PASSWORD=" + AdminPassword
CONST AdminCommandStop = "?STOPSERVER"
CONST AdminCommandStart = "?STARTSERVER"
CONST AdminCommandResetStats = "?RESETSTATS"
'=============================================================

Form.ShowModal

Function ReplaceServerVars(InputString AS STRING,RequestedPath AS STRING) AS STRING
OutputString = InputString
OutputString = ReplaceSubStr$(OutputString,ServerActingFolder,OurPath + DocFolder + "\")
OutputString = ReplaceSubStr$(OutputString,ServerErrorPagesFolder,OurPath + ErrorsFolder + "\")
OutputString = ReplaceSubStr$(OutputString,ServerDataFolder,OurPath + DataFolder + "\")
OutputString = ReplaceSubStr$(OutputString,ServerLogFolder,OurPath + LogFolder + "\")
OutputString = ReplaceSubStr$(OutputString,ServerRequestPath,RequestedPath)
OutputString = ReplaceSubStr$(OutputString,ServerStatus,OurStatusSting)
OutputString = ReplaceSubStr$(OutputString,ServerHits,Str$(NumHits))
OutputString = ReplaceSubStr$(OutputString,ServerWebPageHits,Str$(NumWebPageHits))
OutputString = ReplaceSubStr$(OutputString,ServerErrorHits,Str$(NumErrorHits))
OutputString = ReplaceSubStr$(OutputString,ServerAdminHits,Str$(NumAdminHits))
ReplaceServerVars = OutputString
End Function

Function GetMimeType(Extention AS STRING) AS STRING
FileStream.Open(OurPath + DataFolder + "\Mime.dat",fmOpenRead)

For FileStreamLine = 0 To FileStream.LineCount
    CurrentMimeData = FileStream.ReadLine
    ViewedMimeType = ""
    OldPos = 0
    For LenMimeData = 1 To Len(CurrentMimeData) + 1
        If Mid$(CurrentMimeData,LenMimeData,1) = " " Or LenMimeData = Len(CurrentMimeData) + 1 Then
            If ViewedMimeType = "" Then
                ViewedMimeType = LTrim$(RTrim$(Mid$(CurrentMimeData,OldPos,LenMimeData - OldPos)))
                OldPos = LenMimeData
            Else
                If LTrim$(RTrim$(Mid$(CurrentMimeData,OldPos,LenMimeData - OldPos))) = Extention Then
                    GetMimeType = ViewedMimeType
                    ViewedMimeType = ""
                    FileStream.Close
                    Exit Function
                End If
                OldPos = LenMimeData
            End If
        End If
    Next LenRequestData
Next FileStreamLine
FileStream.Close

GetMimeType = "text/plain"
ViewedMimeType = ""
End Function

SUB Button1Click (Sender AS QBUTTON)
If Button1.Caption = "&Start" Then
	NumHits = 0
	NumWebPageHits = 1
	NumErrorHits = 0
	NumAdminHits = 0
	AdminLoggedIn = 0
	MySockIt = Socket.Open(80)
	
	If MySockIt = -1 Then
		ListBox1.AddItems("Error in starting server")
		ListBox1.ItemIndex = ListBox1.ItemCount - 1
		Form.IcoHandle = ErrorIcon
		Application.IcoHandle = ErrorIcon
		OurStatusSting = "Error"
	Else
		ListBox1.AddItems("Server " + Socket.GetHostIp + " is now active")
		ListBox1.ItemIndex = ListBox1.ItemCount - 1
		SocketRefresh.Enabled = 1
		Button1.Caption = "&Stop"
		Form.IcoHandle = RunningIcon
		Application.IcoHandle = RunningIcon
		OurStatusSting = "Running"
	End If
Else
	Socket.Close(MySockIt)
	ListBox1.AddItems("Server has been stopped")
	ListBox1.ItemIndex = ListBox1.ItemCount - 1
	SocketRefresh.Enabled = 0
	Button1.Caption = "&Start"
	Form.IcoHandle = StoppedIcon
	Application.IcoHandle = StoppedIcon
	OurStatusSting = "Stopped"
End If
END SUB

SUB Button2Click (Sender AS QBUTTON)
ListBox1.Clear
END SUB

SUB Button3Click (Sender AS QBUTTON)
Form.Close
END SUB

SUB TimeOut
'Setting of the parse vars
Command = ""
Path = ""
Protocol = ""
CommandAlloc = 0
PathAlloc = 0
ProtocolAlloc = 0
OldPos = 0

SocketRefresh.Enabled = 0
SocketRefresh.Interval = Delay

'Closing of the client socket NEEDS TO BE DONE!!!!!
Socket.Close(TheirSockIt)

If Socket.ConnectionReady(MySockIt) > 0 Then
    NumHits = NumHits + 1
    TheirSockIt = Socket.Accept(MySockIt)
    RequestData = Socket.ReadLine(TheirSockIt) - Chr$(13)
'    Do
'        DIM RequestData2 AS STRING
'        RequestData2 = Socket.ReadLine(TheirSockIt) - Chr$(13)
'        ListBox1.AddItems(RequestData2)
'    Loop Until Len(RequestData2) = 0
    If Socket.Transferred = -1 Then
        SocketRefresh.Enabled = 1
        Exit Sub
    End If
    LogFile.WriteLine(RequestData + " " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)
    ListBox1.AddItems(RequestData)
    ListBox1.ItemIndex = ListBox1.ItemCount - 1
    
    For LenRequestData = 1 To Len(RequestData) + 1
        If Mid$(RequestData,LenRequestData,1) = " " Or LenRequestData = Len(RequestData) + 1 Then
            If CommandAlloc = 0 Then
                Command = UCase$(LTrim$(RTrim$(Mid$(RequestData,OldPos,LenRequestData - OldPos))))
                OldPos = LenRequestData
                CommandAlloc = 1
            ElseIf PathAlloc = 0 Then
                Path = UCase$(LTrim$(RTrim$(Mid$(RequestData,OldPos,LenRequestData - OldPos))))
                OldPos = LenRequestData
                PathAlloc = 1
            ElseIf ProtocolAlloc = 0 Then
                Protocol = UCase$(LTrim$(RTrim$(Mid$(RequestData,OldPos,LenRequestData - OldPos))))
                OldPos = LenRequestData
                ProtocolAlloc = 1
            End If
        End If
    Next LenRequestData
    
    If Command = "GET" And Left$(Path,Len(WebInterfaceFolderUserNamed) + 1) <> "/" + WebInterfaceFolderUserNamed And Left$(Path,4) <> "/../" Then
        
        CompletePath = OurPath + DocFolder + Path
        
        If FileExists(CompletePath) Then
            FileStream.Open(CompletePath,fmOpenRead)
            PageDataString = FileStream.ReadStr(FileStream.Size)
            PageDataString = ReplaceServerVars(PageDataString,CompletePath)
            FileSize = Len(PageDataString)
            FileStream.Close
            ErrorData = OKErrorData
            MimeType = GetMimeType(Right$(Path,Len(Path) - (RInStr(Path,"."))))
        ElseIf FileExists(CompletePath + "index.htm") Or FileExists(CompletePath + "/index.htm") Then
            If Right$(CompletePath,1) <> "/" Then CompletePath = CompletePath + "/"
            FileStream.Open(CompletePath + "index.htm",fmOpenRead)
            PageDataString = FileStream.ReadStr(FileStream.Size)
            PageDataString = ReplaceServerVars(PageDataString,CompletePath + "index.htm")
            FileSize = Len(PageDataString)
            FileStream.Close
            ErrorData = OKErrorData
            MimeType = "text/html"
        ElseIf FileExists(CompletePath + "index.html") Or FileExists(CompletePath + "/index.html") Then
            If Right$(CompletePath,1) <> "/" Then CompletePath = CompletePath + "/"
            FileStream.Open(CompletePath + "index.html",fmOpenRead)
            PageDataString = FileStream.ReadStr(FileStream.Size)
            PageDataString = ReplaceServerVars(PageDataString,CompletePath + "index.html")
            FileSize = Len(PageDataString)
            FileStream.Close
            ErrorData = OkErrorData
            MimeType = "text/html"
        Else
            NumErrorHits = NumErrorHits + 1
            FileStream.Open(OurPath + ErrorsFolder + "\404.htm",fmOpenRead)
            PageDataString = FileStream.ReadStr(FileStream.Size)
            PageDataString = ReplaceServerVars(PageDataString,Path)
            FileSize = Len(PageDataString)
            FileStream.Close
            ErrorData = NotFoundErrorData
            MimeType = "text/html"
        End If
        
        If MimeType = "text/html" And ErrorData = OKErrorData Then NumWebPageHits = NumWebPageHits + 1
        
        $ESCAPECHARS ON
        HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
        $ESCAPECHARS OFF
        
        Socket.WriteLine(TheirSockIt,HeaderDataString)
        
        Socket.WriteLine(TheirSockIt,PageDataString)
        
    ElseIf Command = "GET" And Left$(Path,Len(WebInterfaceFolderUserNamed) + 1) = "/" + WebInterfaceFolderUserNamed Then
    NumAdminHits = NumAdminHits + 1
        If AdminLoggedIn = 1 Then
            If Right$(Path,Len(AdminCommandResetStats)) = AdminCommandResetStats Then
                LogFile.WriteLine("Admin user logged out " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)
                NumHits = 0
                NumWebPageHits = 1
                NumErrorHits = 0
                NumAdminHits = 0
                $ESCAPECHARS ON
                PageDataString = "<html>\n<head>\n<title>You have reset the statistics</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Statistics reset</h1></td></tr>\n<tr><td align=\"left\">You have successfully reset the statistics</td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Reset the statistics</i></td></tr>\n</table>\n</body>\n</html>"
                $ESCAPECHARS OFF
                PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                FileSize = Len(PageDataString)
                ErrorData = OkErrorData
                MimeType = "text/html"
                
                $ESCAPECHARS ON
                HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
                $ESCAPECHARS OFF
                
                Socket.WriteLine(TheirSockIt,HeaderDataString)
                
                Socket.WriteLine(TheirSockIt,PageDataString)
            ElseIf Right$(Path,Len(AdminCommandLogout)) = AdminCommandLogout Then
                LogFile.WriteLine("Admin user logged out " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)
                AdminLoggedIn = 0
                $ESCAPECHARS ON
                PageDataString = "<html>\n<head>\n<title>You have logged out</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Logged out of admin</h1></td></tr>\n<tr><td align=\"left\">You have successfully logged out of the admin area. <a href=\"../\">Return to the root</a></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Logged out of admin</i></td></tr>\n</table>\n</body>\n</html>"
                $ESCAPECHARS OFF
                PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                FileSize = Len(PageDataString)
                ErrorData = OkErrorData
                MimeType = "text/html"
                
                $ESCAPECHARS ON
                HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
                $ESCAPECHARS OFF
                
                Socket.WriteLine(TheirSockIt,HeaderDataString)
                
                Socket.WriteLine(TheirSockIt,PageDataString)
            ElseIf Right$(Path,Len(AdminCommandStop)) = AdminCommandStop Then
                LogFile.WriteLine("Admin user stopped server " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)

                AdminLoggedIn = 0
                $ESCAPECHARS ON
                PageDataString = "<html>\n<head>\n<title>You have stopped the server</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Server has been stopped</h1></td></tr>\n<tr><td align=\"left\">You have successfully stopped the server</td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Server terminated</i></td></tr>\n</table>\n</body>\n</html>"
                $ESCAPECHARS OFF
                PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                FileSize = Len(PageDataString)
                ErrorData = OkErrorData
                MimeType = "text/html"
                
                $ESCAPECHARS ON
                HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
                $ESCAPECHARS OFF
                
                Socket.WriteLine(TheirSockIt,HeaderDataString)
                
                Socket.WriteLine(TheirSockIt,PageDataString)
                
                Socket.Close(MySockIt)
                ListBox1.AddItems("Server has been stopped")
                ListBox1.ItemIndex = ListBox1.ItemCount - 1
                SocketRefresh.Enabled = 0
                Button1.Caption = "&Start"
                Form.IcoHandle = StoppedIcon
                Application.IcoHandle = StoppedIcon
                OurStatusSting = "Stopped"
            ElseIf Right$(Path,Len(AdminCommandStart)) = AdminCommandStart Then
                Socket.Close(MySockIt)
                
                LogFile.WriteLine("Admin user started server " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)
                AdminLoggedIn = 0
                
                NumHits = 0
                NumWebPageHits = 1
                NumErrorHits = 0
                NumAdminHits = 0
                AdminLoggedIn = 0
                MySockIt = Socket.Open(80)
                
                If MySockIt = -1 Then
                    $ESCAPECHARS ON
                    PageDataString = "<html>\n<head>\n<title>Error when starting server</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Error when starting server</h1></td></tr>\n<tr><td align=\"left\">Error when starting server</td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Error when starting server</i></td></tr>\n</table>\n</body>\n</html>"
                    $ESCAPECHARS OFF
                    PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                    FileSize = Len(PageDataString)
                    ErrorData = OkErrorData
                    MimeType = "text/html"
                    
                    $ESCAPECHARS ON
                    HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"

                    $ESCAPECHARS OFF
                    
                    Socket.WriteLine(TheirSockIt,HeaderDataString)
                    
                    Socket.WriteLine(TheirSockIt,PageDataString)
                    
                    ListBox1.AddItems("Error in starting server")
                    ListBox1.ItemIndex = ListBox1.ItemCount - 1
                    Form.IcoHandle = ErrorIcon
                    Application.IcoHandle = ErrorIcon
                    OurStatusSting = "Error"
                Else
                    $ESCAPECHARS ON
                    PageDataString = "<html>\n<head>\n<title>You have started the server</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Server has been started</h1></td></tr>\n<tr><td align=\"left\">You have successfully started the server</td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Server activated</i></td></tr>\n</table>\n</body>\n</html>"
                    $ESCAPECHARS OFF
                    PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                    FileSize = Len(PageDataString)
                    ErrorData = OkErrorData
                    MimeType = "text/html"
                    
                    $ESCAPECHARS ON
                    HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
                    $ESCAPECHARS OFF
                    
                    Socket.WriteLine(TheirSockIt,HeaderDataString)
                    
                    Socket.WriteLine(TheirSockIt,PageDataString)
                    
                    ListBox1.AddItems("Server " + Socket.GetHostIp + " is now active")
                    ListBox1.ItemIndex = ListBox1.ItemCount - 1
                    SocketRefresh.Enabled = 1
                    Button1.Caption = "&Stop"
                    Form.IcoHandle = RunningIcon
                    Application.IcoHandle = RunningIcon
                    OurStatusSting = "Running"
                End If
            Else
                CompletePath = OurPath + WebInterfaceFolder + "\" + Right$(Path,Len(Path) - Len("/" + WebInterfaceFolderUserNamed + "/"))
                
                If FileExists(CompletePath) Then
                    FileStream.Open(CompletePath,fmOpenRead)
                    PageDataString = FileStream.ReadStr(FileStream.Size)
                    PageDataString = ReplaceServerVars(PageDataString,CompletePath)
                    FileSize = Len(PageDataString)
                    FileStream.Close
                    ErrorData = OkErrorData
                    MimeType = GetMimeType(Right$(Path,Len(Path) - (RInStr(Path,"."))))
                Else
                    NumErrorHits = NumErrorHits + 1
                    FileStream.Open(OurPath + ErrorsFolder + "\404.htm",fmOpenRead)
                    PageDataString = FileStream.ReadStr(FileStream.Size)
                    PageDataString = ReplaceServerVars(PageDataString,Path)
                    FileSize = Len(PageDataString)
                    FileStream.Close
                    ErrorData = NotFoundErrorData
                    MimeType = "text/html"
                End If
                
                $ESCAPECHARS ON
                HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
                $ESCAPECHARS OFF
                
                Socket.WriteLine(TheirSockIt,HeaderDataString)
        
                Socket.WriteLine(TheirSockIt,PageDataString)
            End If
        ElseIf Right$(Path,Len(AdminCommandLogin)) = AdminCommandLogin Then
            LogFile.WriteLine("Admin user logged in " + Str$(TheirSockIt) + " " + Date$ + " " + Time$)
            AdminLoggedIn = 1
            $ESCAPECHARS ON
            PageDataString = "<html>\n<head>\n<title>You have logged in</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Logged in to admin</h1></td></tr>\n<tr><td align=\"left\">You are logged in. <a href=\"../admin/index.htm\">Proceed to admin area</a></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Logged into admin</i></td></tr>\n</table>\n</body>\n</html>"
            $ESCAPECHARS OFF
            PageDataString = ReplaceServerVars(PageDataString,CompletePath)
            FileSize = Len(PageDataString)
            ErrorData = OkErrorData
            MimeType = "text/html"
            
            $ESCAPECHARS ON
            HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
            $ESCAPECHARS OFF
            
            Socket.WriteLine(TheirSockIt,HeaderDataString)
            
            Socket.WriteLine(TheirSockIt,PageDataString)
        Else
            $ESCAPECHARS ON
            PageDataString = "<html>\n<head>\n<title>Enter your username and password</title>\n<style type=\"text/css\">\nbody {	color: #000000;\n	background-color: #ffffff;}\ntd {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\ninput {	font-size: 11px;\n	color: #000000;\n	font-family: geneva, verdana;}\nh1 {	font-size: 15px;}\na {color: #0000ff;\n	text-decoration: none;}\na:hover {color: #ff8800;}\n</style>\n</head>\n\n<body>\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr><td align=\"center\"><h1>Login to admin</h1></td></tr>\n<tr><td align=\"left\"><form method=\"GET\">\nUsername: <input type=\"text\" name=\"username\"><br>\nPassword: <input type=\"password\" name=\"password\"><br>\n<input type=\"submit\" value=\"  Login  \"></form></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr height=\"1\"><td bgcolor=\"#000000\" width=\"100%\"></td></tr>\n<tr height=\"5\"><td></td></tr>\n<tr><td align=\"right\"><i>Nybble WebServer 1.0.0 Access denied</i></td></tr>\n</table>\n</body>\n</html>"
            $ESCAPECHARS OFF
            PageDataString = ReplaceServerVars(PageDataString,CompletePath)
            FileSize = Len(PageDataString)
            ErrorData = OkErrorData
            MimeType = "text/html"
            
            $ESCAPECHARS ON
            HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
            $ESCAPECHARS OFF
            
            Socket.WriteLine(TheirSockIt,HeaderDataString)
            
            Socket.WriteLine(TheirSockIt,PageDataString)
        End If
    ElseIf Command = "GET" And Left$(Path,4) = "/../" Then
        FileStream.Open(OurPath + ErrorsFolder + "\401.htm",fmOpenRead)
        PageDataString = FileStream.ReadStr(FileStream.Size)
        PageDataString = ReplaceServerVars(PageDataString,Path)
        FileSize = Len(PageDataString)
        FileStream.Close
        ErrorData = UnauthorizedErrorData
        MimeType = "text/html"
        
        $ESCAPECHARS ON
        HeaderDataString = HttpProtocUsed + " " + ErrorData + "\nContent-Length: " + Str$(FileSize) + "\nContent-Type: " + MimeType + "\nServer: Nybble WebServer 1.0\n"
        $ESCAPECHARS OFF
        
        Socket.WriteLine(TheirSockIt,HeaderDataString)
        
        Socket.WriteLine(TheirSockIt,PageDataString)
    End If
    
End If

SocketRefresh.Enabled = 1
END SUB

SUB CloseProgram
Socket.Close(TheirSockIt)
Socket.Close(MySockIt)
LogFile.Close
END SUB
